<?php
  /***************************************************************************\
  *  Expresso - Expresso Messenger                                            *
  *  	- Alexandre Correia / Rodrigo Souza							          *
  *  	- JETI - http://jeti-im.org/										  *
  * ------------------------------------------------------------------------- *
  *  This program is free software; you can redistribute it and/or modify it  *
  *  under the terms of the GNU General Public License as published by the    *
  *  Free Software Foundation; either version 2 of the License, or (at your   *
  *  option) any later version.                                               *
  \***************************************************************************/

require_once "class.jabber.inc.php";

class ujabber
{
	private $jabber;
	private $error;

	function __construct()
	{
		
		$this->jabber = new Jabber();
		$this->jabber->username	 = $_SESSION['phpgw_info']['jabberit_messenger']['user'];
		$this->jabber->password	 = $_SESSION['phpgw_info']['jabberit_messenger']['passwd'];
		$this->jabber->server	 = $_SESSION['phpgw_info']['jabberit_messenger']['name_jabberit'];
		$this->jabber->resource  = "JABADD";
	}	
	
	private final function connect()
	{
		if(!$this->jabber->Connect())
		{
			$this->error = "No Connect";
			return false;	
		}
		if(!$this->jabber->SendAuth())
		{
			$this->error = "No Auth";
			return false;
		}
		
		return true;
	}
	
	private final function disconnect()
	{
		
		$this->jabber->Disconnect();
	}
	
	public final function AddNewContact($pNewUser)
	{
		$this->connect();
		$jid	= $pNewUser['uid']."@". $this->jabber->server;
		$id		= 'add_user'.time();
		$name	= $pNewUser['name'];
		$group	= $pNewUser['group'];
		
		if($this->jabber->RosterAddUser($jid,$id,$name,$group))
		{
			$_SESSION['phpgw_info']['jabberit_messenger']['groups_user'][] = $group;
			$_SESSION['phpgw_info']['jabberit_messenger']['groups_user'] = array_unique($_SESSION['phpgw_info']['jabberit_messenger']['groups_user']);
			
			if($this->jabber->Subscribe($jid))
				return true;
		}
		else
		{
			return false;
		}

		$this->disconnect();
	}
	
	public final function getGroupsJabber()
	{
		$groups = array();
		$return = '';
		
		if(!isset($_SESSION['phpgw_info']['jabberit_messenger']['groups_user']))
		{		
			$this->connect();
			$groups = $this->jabber->RosterGroups();
			$this->disconnect();
			
			$groups = array_unique($groups);
			$_SESSION['phpgw_info']['jabberit_messenger']['groups_user'] = $groups;
			
		}else
			$groups = $_SESSION['phpgw_info']['jabberit_messenger']['groups_user'];

		natcasesort($groups);
	
		foreach($groups as $tmp)
			$return .= $tmp . ";";
		
		if( trim($return) != '' )
			$return = substr( $return, 0, strlen($return)-1 );
	
		return $return;
	}
}
?>